
require("mundo")
require("jogador")
require("moeda")
require("efeitos")
require("inimigo")
require("chave")
require("diamante")

res_x=1024
res_y=768

gravidade=.50
tempo_tiro=love.timer.getMicroTime()

paused=false

function love.load()

	love.graphics.setLineWidth(1)

	love.graphics.setCaption("Super Little Guy")

	math.randomseed(os.time());

	ok=love.graphics.setMode(res_x,res_y,true,false)

	love.mouse.setVisible(false)

	tempo_frame=0

	jogador:new(fase)

	local r,g,b,c
	img_ceu = love.graphics.newCanvas()
	love.graphics.setCanvas(img_ceu)
	love.graphics.setPoint(2, "rough")
	for x=0,9 do
		r,g,b,c=5,70,180,0
		for y=0,(res_y-140) do
			love.graphics.setColor(r,g,b,200)
			love.graphics.point(x,y)
			c=c+1
			if c==3 then
				c=0
				r=r+1
				if r>255 then r=255 end
				g=g+1
				if g>255 then g=255 end
				b=b+1
				if b>255 then b=255 end
			end
		end
	end
	love.graphics.setCanvas()

	res_x=1708
	res_y=1281

	mundo:reset()

end

function love.update(dt)

	if not paused then
		if 	tempo_frame==0 then
			key=""
			if love.keyboard.isDown("left") then
				key="left"
			elseif love.keyboard.isDown("right") then
				key="right"
			end
			if jogador.posicao_colisao=="on_top" and (love.keyboard.isDown("up") or jogador.pulo==1) then
				key="up_"..key
			end
			jogador:control(key)
			jogador:atualiza_posicao()
			mundo:trata_crate_lock()
			moeda:testa_colisao_mundo()
			inimigo:testa_colisao_mundo()
			chave:testa_colisao_jogador()
			chave:cria_efeito()
			jogador:checa_atualiza_mundo()
			if jogador.atualiza_mundo_x==true then
				mundo:atualiza_posicao_x()
				moeda:atualiza_posicao_x()
				efeito:atualiza_posicao_x()
				inimigo:atualiza_posicao_x()
				chave:atualiza_posicao_x()
				diamante:atualiza_posicao_x()
			end
		end
		tempo_frame=tempo_frame+dt
		if tempo_frame>=.02 then
			tempo_frame=0
		end
	end
end

function love.draw()

	love.graphics.setColor(255,255,255)
	love.graphics.clear()

	love.graphics.scale(0.60,0.60)

	inimigo:draw()
	mundo:draw()
	chave:exibe_icones()
	moeda:draw()
	chave:draw()
	jogador:draw()
	efeito:draw()
	diamante:draw()

	love.graphics.setColor(255,255,255)
	love.graphics.scale(2,2)
	if not paused then
		love.graphics.print(jogador.pontos,5,20)
	else
		love.graphics.print("Game paused",5,20)
	end

	love.graphics.print(love.timer.getFPS(),5,40)

end

function love.keyreleased(key)

	if jogador.pulo==0 then
		jogador.frame=0
	end
	jogador.tempo_frame=0

end

function love.keypressed(key, unicode)
	if key=="escape" then
		love.event.quit()
	end
	if key=="pause" then
		paused=not paused
	end
end

function love.mousepressed(x, y, k)

end

function love.mousereleased(x, y, k)

end

function checa_colisao(ax1,ay1,aw,ah, bx1,by1,bw,bh)
	local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh

	return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end

function math.dist(x1,y1, x2,y2)
	return ((x2-x1)^2+(y2-y1)^2)^0.5
end
